/*
# pgrm: concatmfs - takes multiple mfs files and concatenates them into
# pgrm:             one mfs file.
*/

#include <stdio.h>
#include <string.h>
#include <mfs.h>


main(argc, argv)
int argc; char **argv;
{
char **names;
int   nfiles, num, i, j, n, m;
MFS  *inp, *out;
FILE *fp;

    procargs(argc, argv, &names, &nfiles);

    num = 0;
    for ( i = 1 ; i < nfiles ; i++ )
    {
       if ((fp = fopen(names[i], "r")) == NULL)
          syserr(argv[0], "fopen", names[i]);
       if ((n = fscanf(fp, "%d", &m)) != 1)
          syserr(argv[0], "fscanf", names[i]);
       num += m;
       fclose(fp);
    }
    out = allocmfs(num);

    for ( i = 1 ; i < nfiles ; i++ )
    {
       inp = readmfsfile(names[i]);
       for ( j = 0 ; j < inp->num ; j++ )
          appendmfs(out, inp->values[j]);
       freemfs(inp);
    }

    writemfsfile(names[0], out);
    freemfs(out);
    free_names(names, nfiles);
}



procargs(argc, argv, names, nfiles)
int	argc, *nfiles;
char	***names, **argv;
{
   int i;

   if (argc < 3)
      fatalerr(argv[0], "Usage", "out.mfs   inp1.mfs inp2.mfs ...");

   *nfiles = argc - 1;
   if ((*names = (char **)calloc(*nfiles, sizeof(char *))) == NULL)
      syserr("procargs", "space for file array pointers", "calloc");

   for (i = 0; i < *nfiles; i++)
      (*names)[i] = strdup(argv[i+1]);
}
