/*
# pgrm: concmis - takes multiple mis files and concatenates them into
# pgrm:           one mis file.
*/

#include <stdio.h>
#include <string.h>
#include <sys/param.h>
#include <ihead.h>
#include <mis.h>


main(argc, argv)
int argc; char **argv;
{
char **names;
int   nfiles, i, n, num, siz;
MIS  *inp, *out;
unsigned char *data;
int truedepth, truewidth, trueheight;

    procargs(argc, argv, &names, &nfiles);

    for ( i = 1, num = 0 ; i < nfiles ; i++ )
    {
       inp = readmishdr(names[i]);

       if (i == 1)
       {
          truewidth  = inp->entw;
          trueheight = inp->enth;
          truedepth  = inp->misd;
       }
       else
       {
          if (inp->entw != truewidth)
             fatalerr(argv[0], names[i], "entries have incompatible width");
          if (inp->enth != trueheight)
             fatalerr(argv[0], names[i], "entries have incompatible height");
          if (inp->misd != truedepth)
             fatalerr(argv[0], names[i], "entries have incompatible depth");
       }

       num += inp->ent_num;
       if (i == nfiles-1)
          out = allocmis(names[0], inp->misd, atoi(inp->head->density),
                                   inp->entw, inp->enth, num);

       freemishdr(inp);
    }

    for ( i = 1 ; i < nfiles ; i++ )
    {
       inp = readmisfile(names[i]);
       siz = SizeFromDepth(inp->entw, inp->enth, inp->misd);

       for ( n = 0, data = inp->data ; n < inp->ent_num ; n++, data += siz )
           appendmis(data, inp->entw, inp->enth, out);

       freemis(inp);
       fprintf(stdout, "%8d/%d appended %s\r", i, nfiles-1, names[i]);
       fflush(stdout);
    }
    fprintf(stdout, "\n");

    set_compression(out->head, CCITT_G4);
    writemisfile(names[0], out);
    freemis(out);

    free_names(names, nfiles);
}


procargs(argc, argv, names, nfiles)
int	argc, *nfiles;
char	***names, **argv;
{
   int i;

   if (argc < 3)
      fatalerr(argv[0], "Usage", "out.mis   inp1.mis inp2.mis ...");

   *nfiles = argc - 1;
   if ((*names = (char **)calloc(*nfiles, sizeof(char *))) == NULL)
      syserr("procargs", "space for file array pointers", "calloc");

   for (i = 0; i < *nfiles; i++)
      (*names)[i] = strdup(argv[i+1]);
}
