/*
# pgrm: dumpidhr - reads the header of an IHead image and prints out the
# pgrm:            contents of the header in a formatted report.
*/

/************************************************************/
/*         File Name: Dumpihdr.c                            */
/*         Package:   NIST Standard Image Header            */
/*         Author:    Michael D. Garris                     */
/*         Date:      4/26/89                               */
/*                                                          */
/*         Modified 12/27/90 by Stan Janet to accept any    */
/*            number of filenames on the command line.      */
/************************************************************/

#include <stdio.h>
#include <ihead.h>

/************************************************************/
/* Read in an image header from the given image files and   */
/* print them to standard output.                           */
/************************************************************/

main(argc,argv)
int argc;
char *argv[];
{
int i;

/*
procargs(argc,argv,&imagefile);
*/

for (i=1; i<argc; i++)
	process(argv[i]);

exit(0);
}

/************************************************************/

process(file)
char *file;
{
register FILE *fp;
register IHEAD *head;
extern IHEAD *readihdr();

/* open the image file */
fp = fopen(file,"r");
if (fp == (FILE *) NULL) {
	fprintf(stderr,"Unable to open ihead file %s.\n",file);
	exit(-1);
}

	/* read in the header */
head = readihdr(fp);

	/* close the image file */
(void) fclose(fp);

	/* dump the header info to standard output */
printihdr(head,stdout);

	/* free the header structure */
free(head);
}

/*
procargs(argc,argv,filename)
int argc;
char *argv[],**filename;
{
if (argc < 2) {
	(void) fprintf(stderr,"Usage: dumpihdr <image file>\n");
	exit(-1);
}
*filename = argv[1];
}
*/
