#include <stdio.h>
#include <string.h>
#include <sys/param.h>
#include <ihead.h>
#include <mfs.h>
#include <mis.h>
#include <mit.h>

main(argc,argv)
int argc;
char **argv;
{
  MIT *mit;
  MIS *mis;
  MFS *names;
  int i, j;
  char tmp[MAXPATHLEN], misfile[MAXPATHLEN], *pathto;

  procargs(argc,argv, &names, &pathto);
  for ( j = 0 ; j < names->num ; j++ )
  {
     mit = readmitfile(names->values[j]);
     if (pathto != NULL)  /* must add a path prefix to the entries */
     {
        for ( i = 0 ; i < mit->num ; i++ )
        {
           sprintf(tmp, "%s/%s", pathto, mit->values[i]);
           if (strlen(tmp) < MAXMITLENGTH)
           {
              free(mit->values[i]);
              mit->values[i] = strdup(tmp);
           }
        }
     }
     mis = misfrmit(mit);
     strcpy(misfile,names->values[j]);
     newext(misfile,MAXPATHLEN,MIS_EXT);
     set_compression(mis->head, CCITT_G4);
     writemisfile(misfile,mis);
     freemit(mit);
     freemis(mis);
  }
  freemfs(names);
  free(pathto);
  exit(0);
}

procargs(argc, argv, names, pathto)
int       argc; char **pathto;
char    **argv; MFS **names;
{
extern int getopt(), optind;
extern char *optarg;
int c, nmitfiles;

   if (argc < 2)
      usage(argv);

   *pathto = NULL;
   while ((c = getopt(argc, argv, "p:")) != -1)
      switch (c)
      {  
          case 'p' : *pathto = strdup(optarg); break;
          default  :  usage(argv);
      }

   if ((nmitfiles = argc - optind) < 1)
      usage(argv);

   *names = allocmfs(nmitfiles);
   for ( c = 0 ; c < nmitfiles ; c++ )
      appendmfs(*names, argv[optind++]);
}

usage(argv)
char **argv;
{
   fprintf(stderr, "Usage: %s:\n", argv[0]);
   fprintf(stderr,
      "\t-p  pathname - optional path to prepend to files named in mitfile\n");
   fprintf(stderr, "\t    mitfiles...\n");
   exit(1);
}

