/*
# pgrm: normmis - performs size and orientation normalization on a misfile.
# pgrm:           takes 128x128 chars and produces 32x32 mis entries.
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <defs.h>
#include <ihead.h>
#include <mis.h>
#include <mfs.h>

#define ES  	  32
#define ES4     4*ES            /* always 4 ES          */


main(argc, argv)
int argc; char **argv;
{
MFS *names;
int   i, n, progress;
MIS   *inp, *out;
float *sfctr, *scal_x, *scal_y;

   procargs(argc, argv, &names, &progress);

   for ( i = 0 ; i < names->num ; i++)
   {
      inp = readmisfile(names->values[i]);

      if ((inp->misd != 1))
         fatalerr(argv[0], names->values[i], "not binary data");
      if (!((inp->enth == ES ) && (inp->entw == ES )) &&
          !((inp->enth == ES4) && (inp->entw == ES4))  )
         fatalerr(argv[0], names->values[i],
            "not 32x32 nor 128x128 mis entries");

      if (inp->entw == ES4)
      {  
         if (progress == TRUE)
            fprintf(stdout, "doing %4d chars of %s\r",
               inp->ent_num, names->values[i]), fflush(stdout);

         norm_2nd_gen2(&out, &scal_x, &scal_y, inp);
         freemis(inp);   
         free(scal_x);
         free(scal_y); 
         shear_mis(&inp, &sfctr, out);  
         freemis(out); 
         free(sfctr);
         set_compression(inp->head, CCITT_G4);
         newext(names->values[i], strlen(names->values[i]), "nrm");
         writemisfile(names->values[i], inp);
      }  
      if (progress == TRUE)
         fprintf(stdout, "\n");


      freemis(inp);
   }
}



procargs(argc, argv, names, progress)
int	  argc, *progress;
char	**argv; MFS **names;
{
extern int getopt(), optind;
int c;

   if (argc < 2)
      usage(argv);

   *progress = FALSE;
   while ((c = getopt(argc, argv, "v")) != -1)
      switch (c)
      {  
          case 'v' : *progress = TRUE; break;
          default  :  usage(argv);
      }

   if (argc - optind != 1)
      usage(argv);

   *names = readmfsfile(argv[optind]);
}

usage(argv)
char **argv;
{
   fprintf(stderr, "Usage: %s:\n", argv[0]);
   fprintf(stderr, "\t-v  be verbose - notify completion of each image\n");
   fprintf(stderr, "\t    mfs_of_misfiles\n");
   exit(1);
}
