/*
# pgrm: showmis - dumps a text representation of images held in a mis file
# pgrm:           as a crude method of display.
*/

#include <stdio.h>
#include <ihead.h>
#include <mis.h>

main(argc, argv)
int argc; char **argv;
{  
  procargs(argc, argv);
  show_mis(argv[1]);
}

procargs(argc, argv)
int     argc; char **argv;
{
   if (argc != 2)
      fatalerr("Usage", argv[0], "misfile");
}

show_mis(misfile)
char *misfile; 
{ 
int   j, k, l;
MIS   *mis;
char  *data8, *dptr;
 
     mis = readmisfile(misfile);
 
     if (mis->misd != 1)
        fatalerr("show_mis", misfile, "incorrect entry size or depth");

     if ((data8 = (char *)malloc(mis->misw * mis->mish * sizeof(char))) == NULL)
        syserr("show_mis", misfile, "unable to allocate 8 bit space");

     bits2bytes(mis->data, data8, mis->misw * mis->mish);

     for (dptr = data8, j = 0 ; j < mis->ent_num ; j++ )
     {   
        for ( k = 0 ; k < mis->enth ; k++ )
           for ( l = 0 ; l < mis->entw ; l++ )
              fprintf(stdout, "%c%c", ( *dptr++ ) ? '#' : '.',
                                      ((l+1) % mis->misw) ? ' ' : '\n');
        fprintf(stdout, "\n");
     }   

     free(data8);
     freemis(mis);
} 
