/*
# proc: syserr - exits on error with a status of -1, printing to stderr a
# proc:          caller-defined message and the system call error associated
# proc:          with errno.
*/

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

void syserr(funcname, syscall, msg)
char *funcname, *syscall, *msg;
{
   int err;

   err = errno;

   (void) fflush(stdout);
   if(msg == NULL)
      (void) fprintf(stderr,"ERROR: %s: %s (%d",funcname,syscall,err);
   else
      (void) fprintf(stderr,"ERROR: %s: %s: %s (%d",funcname,syscall,msg,err);
   if(err > 0)
      (void) fprintf(stderr,"; %s)\n",strerror(err));
   else
      (void) fprintf(stderr,")\n");
   (void) fflush(stderr);

   exit(-1);
}
